import { Object3DProps } from "@react-three/fiber";
import React from "react";
import { Object3D } from "three";
import { SpawnSetup } from "./ParticlesContext";
import { ValueFactory } from "./util/ValueFactory";
export declare type EmitterProps = Object3DProps & {
    count?: ValueFactory<number>;
    setup?: SpawnSetup;
    continuous?: boolean;
};
export declare const Emitter: React.ForwardRefExoticComponent<Pick<EmitterProps, "children" | "quaternion" | "position" | "attach" | "args" | "key" | "onUpdate" | "up" | "scale" | "rotation" | "matrix" | "layers" | "dispose" | "id" | "uuid" | "name" | "type" | "parent" | "modelViewMatrix" | "normalMatrix" | "matrixWorld" | "matrixAutoUpdate" | "matrixWorldNeedsUpdate" | "visible" | "castShadow" | "receiveShadow" | "frustumCulled" | "renderOrder" | "animations" | "userData" | "customDepthMaterial" | "customDistanceMaterial" | "isObject3D" | "onBeforeRender" | "onAfterRender" | "applyMatrix4" | "applyQuaternion" | "setRotationFromAxisAngle" | "setRotationFromEuler" | "setRotationFromMatrix" | "setRotationFromQuaternion" | "rotateOnAxis" | "rotateOnWorldAxis" | "rotateX" | "rotateY" | "rotateZ" | "translateOnAxis" | "translateX" | "translateY" | "translateZ" | "localToWorld" | "worldToLocal" | "lookAt" | "add" | "remove" | "removeFromParent" | "clear" | "getObjectById" | "getObjectByName" | "getObjectByProperty" | "getWorldPosition" | "getWorldQuaternion" | "getWorldScale" | "getWorldDirection" | "raycast" | "traverse" | "traverseVisible" | "traverseAncestors" | "updateMatrix" | "updateMatrixWorld" | "updateWorldMatrix" | "toJSON" | "clone" | "copy" | "addEventListener" | "hasEventListener" | "removeEventListener" | "dispatchEvent" | "count" | keyof import("@react-three/fiber/dist/declarations/src/core/events").EventHandlers | "setup" | "continuous"> & React.RefAttributes<Object3D<import("three").Event>>>;
