import React from "react";
import { DepthTexture } from "three";
import { iCSMProps } from "three-custom-shader-material";
import CustomShaderMaterialImpl from "three-custom-shader-material/vanilla";
import { Shader } from "../shaders";
export declare type MeshParticlesMaterialProps = Omit<iCSMProps, "ref"> & {
    billboard?: boolean;
    softness?: number;
    scaleFunction?: string;
    colorFunction?: string;
    softnessFunction?: string;
    depthTexture?: DepthTexture;
};
export declare type MeshParticlesMaterial = CustomShaderMaterialImpl & {
    __vfx: {
        shader: Shader;
    };
};
export declare const MeshParticlesMaterial: React.ForwardRefExoticComponent<Omit<iCSMProps, "ref"> & {
    billboard?: boolean | undefined;
    softness?: number | undefined;
    scaleFunction?: string | undefined;
    colorFunction?: string | undefined;
    softnessFunction?: string | undefined;
    depthTexture?: DepthTexture | undefined;
} & React.RefAttributes<MeshParticlesMaterial>>;
