import { RenderCallback } from "@react-three/fiber";
import { MeshParticles } from "../MeshParticles/useMeshParticles";
export declare type GLSLType = "float" | "vec2" | "vec3" | "vec4" | "mat3" | "mat4" | "sampler2D" | "samplerCube" | "bool";
export declare type GLSLChunk = string;
export declare type VariableQualifier = "uniform" | "attribute" | "varying";
export declare type Uniform<T = any> = {
    type: GLSLType;
    value: T;
};
export declare type Uniforms = Record<string, Uniform>;
export declare type Varying<T = any> = {
    type: GLSLType;
};
export declare type Varyings = Record<string, Varying>;
export declare type Attribute<T = any> = {
    type: GLSLType;
};
export declare type Attributes = Record<string, Attribute>;
export declare type UpdateCallback = RenderCallback;
export declare type Shader<U = Uniforms, V = Varyings, A = Attributes> = {
    uniforms: U;
    varyings: V;
    attributes: A;
    vertexHeader: GLSLChunk;
    vertexMain: GLSLChunk;
    fragmentHeader: GLSLChunk;
    fragmentMain: GLSLChunk;
    config: Record<string, any>;
    resetConfig?: (mesh: MeshParticles) => void;
    applyConfig?: (mesh: MeshParticles, index: number) => void;
    update?: RenderCallback;
};
